#include <types.h>
#include <mod/mod.h>
#include "stdio.h"

extern struct mod_ops mod_finished;

static struct mod_ops *all_mods[] = {
    &mod_finished,
    NULL
};

static struct mod_ops mod_x;

#define MOD_OP(op, ...)					\
	(( mod_x.op != NULL ) ? mod_x.op( __VA_ARGS__ )	\
	: (typeof(mod_x.op(__VA_ARGS__))) 0)

/* Memory Management Interface */
int  mod_init(char *name)
{
    int i;

    for( i = 0; all_mods[i] != NULL; i++ ){
        mod_x = *all_mods[i];
        if( strcmp(mod_x.name, name) == 0 )
            break;
    }
    if(all_mods[i] == NULL ) {
        printf("Could not find mod:%s\n", name);
		return -1;
	}
    MOD_OP(init);
	return 0;
}

void mod_operation_1(type1_t para1,type2_t para2,type3_t para3)
{
    MOD_OP(operation_1, para1, para2, para3);
}

void mod_operation_2(type1_t para1,type2_t para2,type3_t para3)
{
    MOD_OP(operation_2, para1, para2, para3);
}
void mod_operation_3(type1_t para1,type2_t para2,type3_t para3)
{
    MOD_OP(operation_3, para1, para2, para3);
}
